#include <stdio.h>
#include <stdlib.h>

typedef int type;

typedef struct node {
 	type data;
	struct node *next;
} Node;


typedef struct queue{
	int size;
	Node *first;
	Node *last;
} Queue;


//Interface
int IsEmpty(Queue *q);
Queue * InitQueue();
Node * InitNode();
void Enqueue(Queue *q, type x);
type Dequeue(Queue *q);
void PrintQueue(Queue *q);
void PrintFirst(Queue *q);
void PrintLast(Queue *q);

int IsEmpty(Queue *q){
	return q->size==0;
}

Queue * InitQueue(){
	Queue *newQueue;
	newQueue = (Queue *) malloc(sizeof(Queue));
	newQueue->size=0;
	newQueue->first = NULL;
	newQueue->last = NULL;
	return newQueue;
}

Node * InitNode(){
	Node *newNode = (Node *) malloc(sizeof(Node));
	newNode->next=NULL;
	return newNode;
}

void Enqueue(Queue *q, type x){
	Node *newNode = InitNode();
	newNode->data=x;

	if(IsEmpty(q)){
		q->first = newNode;
		q->last = newNode;
	}
	else{
		q->last->next = newNode;
		q->last = newNode;
	}

	printf("Enqueue %d\n", x);

	q->size++;
}

type Dequeue(Queue *q){
	int result=-1;
	Node *tmp;

	if(!IsEmpty(q)){
		result = q->first->data;
		if(q->size==1){
			free(q->first);
			q->first = NULL;
			q->last = NULL;
		}
		else{
			tmp = q->first;
			q->first = q->first->next;
			free(tmp);
		}
			printf("Dequeue %d\n", result);

		q->size--;
	}

	return result;
}

void PrintQueue(Queue *q){
	int i;

	Node *tmp = q->first;
	for(i=0; i<q->size; i++, tmp=tmp->next) printf("%d\t", tmp->data);
	printf("\n");
}

void PrintFirst(Queue *q){
	printf("First Node:%d\n", q->first->data);
}

void PrintLast(Queue *q){
	printf("Last Node:%d\n", q->last->data);
}
